/*
 * ExhibitionFacadeBean.java
 *
 * Created on October 23, 2006, 2:32 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.schwarcz.enamels.model;
import com.schwarcz.util.LoggingFactory;
import java.util.List;
import com.schwarcz.enamels.model.Exhibition;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.Stateless;
import javax.persistence.*;
import org.apache.log4j.*;

/**
 *
 * @author Carl
 */
@Stateless(mappedName="ExhibitionFacade")
public class ExhibitionFacadeBean implements ExhibitionFacadeRemote, ExhibitionFacadeLocal {
    
    @PersistenceContext(unitName="EnamelPU")
    EntityManager em;
    
    Logger logger;
    
    /** Creates a new instance of ExhibitionFacadeBean */
    public ExhibitionFacadeBean() {
        
    }
    
   
    @PostConstruct
    private void init(){
        logger = LoggingFactory.getLogger(this.getClass().getName());
        logger.info("init complete");
        logger.setLevel(Level.DEBUG);
    }
    
    @PreDestroy
    private void teardown(){
        logger = null;
    }
    
    public List<Exhibition> findByEnamel(String id) {
        logger.info("findByEnamel");
        List<Exhibition> result;
        
        String findByEnamel = "SELECT ex FROM Exhibition AS ex, Showpiece AS sh WHERE sh.enamelId = :enamelId AND sh.showId = ex.id ORDER BY ex.year";
        logger.debug("query = " + findByEnamel);
        Query query = em.createQuery(findByEnamel);
        logger.debug("param enamelId = " + id);
        query.setParameter("enamelId", id);
        result = (List<Exhibition>) query.getResultList();
        return result;
    }
    
    
    public List testQuery(String queryString) {
        Query query;
        List results;
        logger.debug("testQuery: " + queryString);
        
        results = em.createQuery(queryString).getResultList();
        
        return results;
    }
    
    public boolean isReachable() {
        return true;
    }
    
}
