/*
 * Logging.java
 *
 * Created on November 2, 2006, 11:59 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.schwarcz.util;

import java.util.Properties;
import java.io.*;
import org.apache.log4j.*;

/**
 *
 * @author Carl
 */
public class LoggingFactory {
    
    static Properties props = null;
    
    static {
        try {
            initLog4j();
        }
        catch (Exception e){
            
        }
    }
    
    /** Creates a new instance of Logging */
    public LoggingFactory() {
    }
    
    public static Logger getLogger(Object o) {
        try {
            
            if (props == null){
                initLog4j();
            }
            
            if (o instanceof String){
                return Logger.getLogger((String)o);
            }
            else if (o instanceof Class) {
                return Logger.getLogger((Class)o);
            }
            else {
                throw new IllegalArgumentException("Logger not secified by either a String or a Class.");
            }
       
        } catch (Exception ex) {
            System.out.println ("Failed to initialize logging.");
            ex.printStackTrace();
            return null;
        }
    }
    
    
    synchronized private static void initLog4j() throws Exception {
        if (props == null){
            props = loadProperties("log4j.properties");
            props.list(System.out);
            PropertyConfigurator.configure(props);
            Logger.getLogger("con.schwarcz.enamels").info("Logging initialized");
        }
    }
    
    private static InputStream loadStream(String name) throws Exception {
        InputStream stream = new LoggingFactory().getClass().getResourceAsStream(name);
        if (stream == null){
            throw new Exception  ("no InputStream for " + name);
        }
        
        return stream;
        
    }
    
    
    public static Properties loadProperties(String name) throws Exception {
        
        Properties props = new Properties();
        
        try {
            props.load(loadStream(name));
            //props.list(System.out);
        } catch (IOException ioe){
            throw new Exception("failed to load " + name);
        }
        
        return props;
    }
}
